.align 64
.globl AES_192_KE_w_sse
AES_192_KE_w_sse:

   movl   $12, 240(%rsi)
   movdqu (%rdi), %xmm1
   movdqu 16(%rdi), %xmm3
   movdqa %xmm1, (%rsi)
   movdqa %xmm3, %xmm5

   aeskeygenassist $0x1, %xmm3, %xmm2
   call PREPARE_ROUNDKEY_192
   shufpd $0, %xmm1, %xmm5
   movdqa %xmm5, 16(%rsi)
   movdqa %xmm1, %xmm6
   shufpd $1, %xmm3, %xmm6
   movdqa %xmm6, 32(%rsi)

   aeskeygenassist $0x2, %xmm3, %xmm2
   call PREPARE_ROUNDKEY_192
   movdqa %xmm1, 48(%rsi)
   movdqa %xmm3, %xmm5

   aeskeygenassist $0x4, %xmm3, %xmm2
   call PREPARE_ROUNDKEY_192
   shufpd $0, %xmm1, %xmm5
   movdqa %xmm5, 64(%rsi)
   movdqa %xmm1, %xmm6
   shufpd $1, %xmm3, %xmm6
   movdqa %xmm6, 80(%rsi)

   aeskeygenassist $0x8, %xmm3, %xmm2
   call PREPARE_ROUNDKEY_192
   movdqa %xmm1, 96(%rsi)
   movdqa %xmm3, %xmm5

   aeskeygenassist $0x10, %xmm3, %xmm2
   call PREPARE_ROUNDKEY_192
   shufpd $0, %xmm1, %xmm5
   movdqa %xmm5, 112(%rsi)
   movdqa %xmm1, %xmm6
   shufpd $1, %xmm3, %xmm6
   movdqa %xmm6, 128(%rsi)

   aeskeygenassist $0x20, %xmm3, %xmm2
   call PREPARE_ROUNDKEY_192
   movdqa %xmm1, 144(%rsi)
   movdqa %xmm3, %xmm5

   aeskeygenassist $0x40, %xmm3, %xmm2
   call PREPARE_ROUNDKEY_192
   shufpd $0, %xmm1, %xmm5
   movdqa %xmm5, 160(%rsi)
   movdqa %xmm1, %xmm6
   shufpd $1, %xmm3, %xmm6
   movdqa %xmm6, 176(%rsi)

   aeskeygenassist $0x80, %xmm3, %xmm2
   call PREPARE_ROUNDKEY_192
   movdqa %xmm1, 192(%rsi)

   ret

.align 64
PREPARE_ROUNDKEY_192: 
   pshufd $0x55, %xmm2, %xmm2 
   movdqu %xmm1, %xmm4
   pslldq $4, %xmm4
   pxor   %xmm4, %xmm1
   pslldq $4, %xmm4
   pxor   %xmm4, %xmm1
   pslldq $4, %xmm4
   pxor   %xmm4, %xmm1
   pxor   %xmm2, %xmm1
   pshufd $0xff, %xmm1, %xmm2
   movdqu %xmm3, %xmm4
   pslldq $4, %xmm4
   pxor   %xmm4, %xmm3
   pxor   %xmm2, %xmm3
   ret
